'''Partendo da una parola e' possibile, a volte, formare altre parole rimuovendo
una lettera. Ad esempio, partendo dalla parola "parlare" possiamo rimuovere la
"l" ottenendo "parare", rimuovendo poi la "p" otteniamo "arare" e togliendo
l'iniziale "a" si ha "rare". Partendo da una parola possiamo considerare tutte
le parole che si ottengono rimuovendo una lettera e poi possiamo ripetere la
stessa operazione a partire da quest'ultime e cosi' via ottenendo un albero di
parole. 
Ad esempio, nel  file palla.pdf e' riportato  l'albero che si ottiene partendo 
dalla parola "palla" facendo riferimento alle parole lecite contenute 
nel file parole.txt.
Come si vede anche dall'esempio di "palla", nessun nodo dell'albero deve 
avere due figli con la stessa parola mentre una stessa parola puo' apparire 
piu' volte nell'albero.


1) Definire una classe Nodo che rappresenta un nodo di un albero di parole.

 
2) scrivere una funzione es(s, fname)  ricorsiva o che faccia 
   uso di funzioni ricorsive che 
 - prende in input una parola s e il percorso al file delle parole lecite. 
 - facendo riferimento al file di parole lecite   GENERA l'albero di parole 
   con radice la parola s e RITORNA infine il nodo radice dell'albero 
   (di tipo Node). 


3) scrivere una funzione differenti(nodo) ricorsiva o che faccia uso di 
   funzioni ricorsive, che 
   – prende in input la radice di un albero di parole 
   - restituisce l'insieme delle parole dell'albero.
Nel caso dell'albero generato da 'palla'  l'insieme restituito deve essere
{'la', 'all', 'alla', 'palla', 'pala', 'al', 'ala', 'a'}


4) scrivere una funzione lunghe(nodo,k) ricorsiva o che faccia uso 
   di funzioni ricorsive che 
   – prende in input la radice di un albero di parole e un intero k 
   – restituisce l'insieme delle parole dell'albero che hanno lunghezza k.
Nel caso dell'albero generato da 'palla' se k=3 l'insieme deve 
essere {'ala','all'}


5) scrivere una funzione frequenti(nodo) ricorsiva o che faccia uso di 
funzioni ricorsive che 
   – prende in input la radice di un albero di parole 
   – restituisce l'insieme di parole che compaiono piu' spesso nell'albero.
Nel caso dell'albero generato da 'palla' l'insieme conterra' come unica 
parola la lettera a.

'''

class Nodo:
    #inserire qui il vostro codice per la classe 



def es(s, fname):
    #inserire qui il vostro codice che genera l'albero e restituisce il nodo radice


    
# >>> r1=es('palla','parole.txt')
# >>> r2=es('marea','parole.txt')

#------------------------------------------------------------------------------------


def differenti(nodo):
    # inserire il vostro codice della funzione che dato il nodo radice dell'albero 
    # di parole restituisce l'insieme di parole dell'albero

    
# >>> differenti(r1)
# {'la', 'all', 'alla', 'palla', 'pala', 'al', 'ala', 'a'}
# >>> differenti(r1)
# {'mare', 'rea', 'are', 'e', 'ara', 'area', 'mar', 'a', 'marea', 'ma', 're'}


#----------------------------------------------------------------------------------

def lunghe(nodo,k):
    # inserire il vostro codice della funzione che dato il nodo radice 
    # dell'albero di parole ed un intero k restituisce l'insieme con 
    # le parole dell'albero di lunghezza k.

# >>> lunghe(r,3)
# {'ala', 'all'}
# >>> lunghe(r2,3)
# {'ara', 'mar', 'rea', 'are'}


#----------------------------------------------------------------------------------

def frequenti(nodo):
    # inserire il vostro codice della funzione che dato il nodo radice 
    # dell'albero di parole   restituisce l'insieme con le parole che vi 
    # appaiono con frequenza massima.

# >>> frequenti(r)
# {'a'}
#>>> frequenti(r1)
#{'e', 're'}


#---------------------------------------------------------------------------------




